diff --git a/automation/build/alpine/3.12-arm64v8.dockerfile b/automation/build/alpine/3.12-arm64v8.dockerfile
index f8d3927ee3ed..180c978964aa 100644
--- a/automation/build/alpine/3.12-arm64v8.dockerfile
+++ b/automation/build/alpine/3.12-arm64v8.dockerfile
@@ -20,8 +20,6 @@ RUN apk --no-cache add \
   dtc-dev \
   flex \
   gcc \
-  # gettext for Xen < 4.13
-  gettext \
   git \
   iasl \
   libaio-dev \
diff --git a/automation/build/alpine/3.12.dockerfile b/automation/build/alpine/3.12.dockerfile
index fbf4aa4d3d63..c847aa82d9e2 100644
--- a/automation/build/alpine/3.12.dockerfile
+++ b/automation/build/alpine/3.12.dockerfile
@@ -21,8 +21,6 @@ RUN apk --no-cache add \
   flex \
   g++ \
   gcc \
-  # gettext for Xen < 4.13
-  gettext \
   git \
   grep \
   iasl \
diff --git a/automation/build/centos/7.dockerfile b/automation/build/centos/7.dockerfile
index f5264e02d92f..69dcefb2f011 100644
--- a/automation/build/centos/7.dockerfile
+++ b/automation/build/centos/7.dockerfile
@@ -25,8 +25,6 @@ RUN yum -y update \
         python-devel \
         libuuid-devel \
         pkgconfig \
-        # gettext for Xen < 4.13
-        gettext \
         flex \
         bison \
         libaio-devel \
diff --git a/automation/build/debian/jessie-i386.dockerfile b/automation/build/debian/jessie-i386.dockerfile
index 3f86d91f63c6..b152d658d3b3 100644
--- a/automation/build/debian/jessie-i386.dockerfile
+++ b/automation/build/debian/jessie-i386.dockerfile
@@ -28,8 +28,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         bin86 \
         bcc \
diff --git a/automation/build/debian/jessie.dockerfile b/automation/build/debian/jessie.dockerfile
index 2f19adcad395..1e33e635d2de 100644
--- a/automation/build/debian/jessie.dockerfile
+++ b/automation/build/debian/jessie.dockerfile
@@ -26,8 +26,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         bin86 \
         bcc \
diff --git a/automation/build/debian/stretch-i386.dockerfile b/automation/build/debian/stretch-i386.dockerfile
index c7840d33ab52..d93f74c979ef 100644
--- a/automation/build/debian/stretch-i386.dockerfile
+++ b/automation/build/debian/stretch-i386.dockerfile
@@ -29,8 +29,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         bin86 \
         bcc \
diff --git a/automation/build/debian/stretch.dockerfile b/automation/build/debian/stretch.dockerfile
index 30fcc5288dee..2c086b197cba 100644
--- a/automation/build/debian/stretch.dockerfile
+++ b/automation/build/debian/stretch.dockerfile
@@ -27,8 +27,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         bin86 \
         bcc \
diff --git a/automation/build/debian/unstable-arm64v8.dockerfile b/automation/build/debian/unstable-arm64v8.dockerfile
index 0080c22ba21f..b9b1587f888b 100644
--- a/automation/build/debian/unstable-arm64v8.dockerfile
+++ b/automation/build/debian/unstable-arm64v8.dockerfile
@@ -26,8 +26,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         libfdt-dev \
         bin86 \
diff --git a/automation/build/debian/unstable-i386.dockerfile b/automation/build/debian/unstable-i386.dockerfile
index 6ce54a481b07..1c4928b09eb1 100644
--- a/automation/build/debian/unstable-i386.dockerfile
+++ b/automation/build/debian/unstable-i386.dockerfile
@@ -28,8 +28,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         bin86 \
         bcc \
diff --git a/automation/build/debian/unstable.dockerfile b/automation/build/debian/unstable.dockerfile
index b560337b7a10..6ef28782008c 100644
--- a/automation/build/debian/unstable.dockerfile
+++ b/automation/build/debian/unstable.dockerfile
@@ -26,8 +26,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         bin86 \
         bcc \
diff --git a/automation/build/fedora/29.dockerfile b/automation/build/fedora/29.dockerfile
index 60a5d722668f..e55b06a4517e 100644
--- a/automation/build/fedora/29.dockerfile
+++ b/automation/build/fedora/29.dockerfile
@@ -14,8 +14,6 @@ RUN dnf -y install \
         python3-devel \
         libuuid-devel \
         pkgconfig \
-        # gettext for Xen < 4.13
-        gettext \
         flex \
         bison \
         libaio-devel \
diff --git a/automation/build/suse/opensuse-leap.dockerfile b/automation/build/suse/opensuse-leap.dockerfile
index 5e8111f40b13..bac938541215 100644
--- a/automation/build/suse/opensuse-leap.dockerfile
+++ b/automation/build/suse/opensuse-leap.dockerfile
@@ -22,8 +22,6 @@ RUN zypper install -y --no-recommends \
         flex \
         gcc \
         gcc-c++ \
-        # gettext-tools for Xen < 4.13
-        gettext-tools \
         git \
         glib2-devel \
         glibc-devel \
diff --git a/automation/build/suse/opensuse-tumbleweed.dockerfile b/automation/build/suse/opensuse-tumbleweed.dockerfile
index b165c4824536..3e5771fccd2b 100644
--- a/automation/build/suse/opensuse-tumbleweed.dockerfile
+++ b/automation/build/suse/opensuse-tumbleweed.dockerfile
@@ -22,8 +22,6 @@ RUN zypper install -y --no-recommends \
         flex \
         gcc \
         gcc-c++ \
-        # gettext-tools for Xen < 4.13
-        gettext-tools \
         git \
         glib2-devel \
         glibc-devel \
diff --git a/automation/build/ubuntu/bionic.dockerfile b/automation/build/ubuntu/bionic.dockerfile
index 1e5a27c70f15..e15f54431efb 100644
--- a/automation/build/ubuntu/bionic.dockerfile
+++ b/automation/build/ubuntu/bionic.dockerfile
@@ -27,8 +27,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         bin86 \
         bcc \
diff --git a/automation/build/ubuntu/focal.dockerfile b/automation/build/ubuntu/focal.dockerfile
index 74655b9876d2..9c851c062073 100644
--- a/automation/build/ubuntu/focal.dockerfile
+++ b/automation/build/ubuntu/focal.dockerfile
@@ -26,8 +26,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         bin86 \
         bcc \
diff --git a/automation/build/ubuntu/trusty.dockerfile b/automation/build/ubuntu/trusty.dockerfile
index b4b2f85e7344..b298a515c611 100644
--- a/automation/build/ubuntu/trusty.dockerfile
+++ b/automation/build/ubuntu/trusty.dockerfile
@@ -27,8 +27,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         bin86 \
         bcc \
diff --git a/automation/build/ubuntu/xenial.dockerfile b/automation/build/ubuntu/xenial.dockerfile
index 82171d856dad..2d2ba3e31f63 100644
--- a/automation/build/ubuntu/xenial.dockerfile
+++ b/automation/build/ubuntu/xenial.dockerfile
@@ -27,8 +27,6 @@ RUN apt-get update && \
         pkg-config \
         flex \
         bison \
-        # gettext for Xen < 4.13
-        gettext \
         acpica-tools \
         bin86 \
         bcc \
diff --git a/automation/tests-artifacts/alpine/3.12-arm64v8.dockerfile b/automation/tests-artifacts/alpine/3.12-arm64v8.dockerfile
index 7eb1f22940d6..cb8e9e59bb43 100644
--- a/automation/tests-artifacts/alpine/3.12-arm64v8.dockerfile
+++ b/automation/tests-artifacts/alpine/3.12-arm64v8.dockerfile
@@ -19,8 +19,6 @@ RUN \
   apk add dbus && \
   apk add bash && \
   apk add python2 && \
-  # gettext for Xen < 4.13
-  apk add gettext && \
   apk add zlib && \
   apk add ncurses && \
   apk add texinfo && \