diff --git a/automation/gitlab-ci/containers.yaml b/automation/gitlab-ci/containers.yaml
index ace93eaccf..a6d61980b1 100644
--- a/automation/gitlab-ci/containers.yaml
+++ b/automation/gitlab-ci/containers.yaml
@@ -18,8 +18,80 @@
   after_script:
     - docker logout
 
-debian-unstable-container:
+archlinux-current-container:
+  variables:
+    BUILD_CONTAINER: archlinux/current
+  extends:
+    - .container-build-tmpl
+
+centos-7-2-container:
+  variables:
+    BUILD_CONTAINER: centos/7.2
+  extends:
+    - .container-build-tmpl
+
+centos-7-container:
+  variables:
+    BUILD_CONTAINER: centos/7
+  extends:
+    - .container-build-tmpl
+
+debian-jessie-container:
+  variables:
+    BUILD_CONTAINER: debian/jessie
+  extends:
+    - .container-build-tmpl
+
+debian-jessie-32-container:
+  variables:
+    BUILD_CONTAINER: debian/jessie-i386
+  extends:
+    - .container-build-tmpl
+
+debian-stretch-container:
+  variables:
+    BUILD_CONTAINER: debian/stretch
+  extends:
+    - .container-build-tmpl
+
+debian-stretch-32-container:
+  variables:
+    BUILD_CONTAINER: debian/stretch-i386
   extends:
     - .container-build-tmpl
+
+debian-unstable-container:
   variables:
     BUILD_CONTAINER: debian/unstable
+  extends:
+    - .container-build-tmpl
+
+debian-unstable-32-container:
+  variables:
+    BUILD_CONTAINER: debian/unstable-i386
+  extends:
+    - .container-build-tmpl
+
+ubuntu-trusty-container:
+  variables:
+    BUILD_CONTAINER: ubuntu/trusty
+  extends:
+    - .container-build-tmpl
+
+ubuntu-xenial-container:
+  variables:
+    BUILD_CONTAINER: ubuntu/xenial
+  extends:
+    - .container-build-tmpl
+
+ubuntu-bionic-container:
+  variables:
+    BUILD_CONTAINER: ubuntu/bionic
+  extends:
+    - .container-build-tmpl
+
+ubuntu-focal-container:
+  variables:
+    BUILD_CONTAINER: ubuntu/focal
+  extends:
+    - .container-build-tmpl
diff --git a/automation/gitlab-ci/test-containers.yaml b/automation/gitlab-ci/test-containers.yaml
index 5dbf3902ff..4d5c6ba364 100644
--- a/automation/gitlab-ci/test-containers.yaml
+++ b/automation/gitlab-ci/test-containers.yaml
@@ -197,6 +197,148 @@
 
 # Jobs below this line
 
+.container-archlinux-testtmpl:
+  variables:
+    CONTAINER: archlinux:current
+    BUILD_CONTAINER: archlinux/current
+  needs:
+    - archlinux-current-container
+
+test-archlinux-gcc:
+  extends:
+    - .gcc-x86-64-testbuild
+    - .container-archlinux-testtmpl
+
+test-archlinux-gcc-debug:
+  extends:
+    - .gcc-x86-64-testbuild-debug
+    - .container-archlinux-testtmpl
+
+.container-centos-7-testtmpl:
+  variables:
+    CONTAINER: centos:7
+    BUILD_CONTAINER: centos/7
+  needs:
+    - centos-7-container
+
+test-centos-7-gcc:
+  extends:
+    - .gcc-x86-64-testbuild
+    - .container-centos-7-testtmpl
+
+test-centos-7-gcc-debug:
+  extends:
+    - .gcc-x86-64-testbuild-debug
+    - .container-centos-7-testtmpl
+
+.container-debian-jessie-testtmpl:
+  variables:
+    CONTAINER: debian:jessie
+    BUILD_CONTAINER: debian/jessie
+  needs:
+    - debian-jessie-container
+
+test-debian-jessie-clang:
+  extends:
+    - .clang-x86-64-testbuild
+    - .container-debian-jessie-testtmpl
+
+test-debian-jessie-clang-debug:
+  extends:
+    - .clang-x86-64-testbuild-debug
+    - .container-debian-jessie-testtmpl
+
+test-debian-jessie-gcc:
+  extends:
+    - .gcc-x86-64-testbuild
+    - .container-debian-jessie-testtmpl
+
+test-debian-jessie-gcc-debug:
+  extends:
+    - .gcc-x86-64-testbuild-debug
+    - .container-debian-jessie-testtmpl
+
+.container-debian-32-jessie-testtmpl:
+  variables:
+    CONTAINER: debian:jessie-i386
+    BUILD_CONTAINER: debian/jessie-i386
+  needs:
+    - debian-jessie-32-container
+
+test-debian-jessie-32-clang:
+  extends:
+    - .clang-x86-32-testbuild
+    - .container-debian-32-jessie-testtmpl
+
+test-debian-jessie-32-clang-debug:
+  extends:
+    - .clang-x86-32-testbuild-debug
+    - .container-debian-32-jessie-testtmpl
+
+test-debian-jessie-32-gcc:
+  extends:
+    - .gcc-x86-32-testbuild
+    - .container-debian-32-jessie-testtmpl
+
+test-debian-jessie-32-gcc-debug:
+  extends:
+    - .gcc-x86-32-testbuild-debug
+    - .container-debian-32-jessie-testtmpl
+
+.container-debian-stretch-testtmpl:
+  variables:
+    CONTAINER: debian:stretch
+    BUILD_CONTAINER: debian/stretch
+  needs:
+    - debian-stretch-container
+
+test-debian-stretch-clang:
+  extends:
+    - .clang-x86-64-testbuild
+    - .container-debian-stretch-testtmpl
+
+test-debian-stretch-clang-debug:
+  extends:
+    - .clang-x86-64-testbuild-debug
+    - .container-debian-stretch-testtmpl
+
+test-debian-stretch-clang-8:
+  extends:
+    - .clang-8-x86-64-testbuild
+    - .container-debian-stretch-testtmpl
+
+test-debian-stretch-clang-8-debug:
+  extends:
+    - .clang-8-x86-64-testbuild-debug
+    - .container-debian-stretch-testtmpl
+
+test-debian-stretch-gcc:
+  extends:
+    - .gcc-x86-64-testbuild
+    - .container-debian-stretch-testtmpl
+
+test-debian-stretch-gcc-debug:
+  extends:
+    - .gcc-x86-64-testbuild-debug
+    - .container-debian-stretch-testtmpl
+
+.container-debian-stretch-32-testtmpl:
+  variables:
+    CONTAINER: debian:stretch-i386
+    BUILD_CONTAINER: debian/stretch-i386
+  needs:
+    - debian-stretch-32-container
+
+test-debian-stretch-32-clang-debug:
+  extends:
+    - .clang-x86-32-testbuild-debug
+    - .container-debian-stretch-32-testtmpl
+
+test-debian-stretch-32-gcc-debug:
+  extends:
+    - .gcc-x86-32-testbuild-debug
+    - .container-debian-stretch-32-testtmpl
+
 .container-debian-unstable-testtmpl:
   variables:
     CONTAINER: debian:unstable
@@ -237,3 +379,118 @@ test-debian-unstable-gcc-debug-randconfig:
     - .container-debian-unstable-testtmpl
   variables:
     RANDCONFIG: y
+
+.container-debian-unstable-32-testtmpl:
+  variables:
+    CONTAINER: debian:unstable-i386
+    BUILD_CONTAINER: debian/unstable-i386
+  needs:
+    - debian-unstable-32-container
+
+test-debian-unstable-32-clang-debug:
+  extends:
+    - .clang-x86-32-testbuild-debug
+    - .container-debian-unstable-32-testtmpl
+
+test-debian-unstable-32-gcc-debug:
+  extends:
+    - .gcc-x86-32-testbuild-debug
+    - .container-debian-unstable-32-testtmpl
+
+.container-ubuntu-trusty-testtmpl:
+  variables:
+    CONTAINER: ubuntu:trusty
+    BUILD_CONTAINER: ubuntu/trusty
+  needs:
+    - ubuntu-trusty-container
+
+test-ubuntu-trusty-gcc:
+  extends:
+    - .gcc-x86-64-testbuild
+    - .container-ubuntu-trusty-testtmpl
+
+test-ubuntu-trusty-gcc-debug:
+  extends:
+    - .gcc-x86-64-testbuild-debug
+    - .container-ubuntu-trusty-testtmpl
+
+.container-ubuntu-xenial-testtmpl:
+  variables:
+    CONTAINER: ubuntu:xenial
+    BUILD_CONTAINER: ubuntu/xenial
+  needs:
+    - ubuntu-xenial-container
+
+test-ubuntu-xenial-clang:
+  extends:
+    - .clang-x86-64-testbuild
+    - .container-ubuntu-xenial-testtmpl
+
+test-ubuntu-xenial-clang-debug:
+  extends:
+    - .clang-x86-64-testbuild-debug
+    - .container-ubuntu-xenial-testtmpl
+
+test-ubuntu-xenial-gcc:
+  extends:
+    - .gcc-x86-64-testbuild
+    - .container-ubuntu-xenial-testtmpl
+
+test-ubuntu-xenial-gcc-debug:
+  extends:
+    - .gcc-x86-64-testbuild-debug
+    - .container-ubuntu-xenial-testtmpl
+
+.container-ubuntu-bionic-testtmpl:
+  variables:
+    CONTAINER: ubuntu:bionic
+    BUILD_CONTAINER: ubuntu/bionic
+  needs:
+    - ubuntu-bionic-container
+
+test-ubuntu-bionic-clang:
+  extends:
+    - .clang-x86-64-testbuild
+    - .container-ubuntu-bionic-testtmpl
+
+test-ubuntu-bionic-clang-debug:
+  extends:
+    - .clang-x86-64-testbuild-debug
+    - .container-ubuntu-bionic-testtmpl
+
+test-ubuntu-bionic-gcc:
+  extends:
+    - .gcc-x86-64-testbuild
+    - .container-ubuntu-bionic-testtmpl
+
+test-ubuntu-bionic-gcc-debug:
+  extends:
+    - .gcc-x86-64-testbuild-debug
+    - .container-ubuntu-bionic-testtmpl
+
+.container-ubuntu-focal-testtmpl:
+  variables:
+    CONTAINER: ubuntu:focal
+    BUILD_CONTAINER: ubuntu/focal
+  needs:
+    - ubuntu-focal-container
+
+test-ubuntu-focal-gcc:
+  extends:
+    - .gcc-x86-64-testbuild
+    - .container-ubuntu-focal-testtmpl
+
+test-ubuntu-focal-gcc-debug:
+  extends:
+    - .gcc-x86-64-testbuild-debug
+    - .container-ubuntu-focal-testtmpl
+
+test-ubuntu-focal-clang:
+  extends:
+    - .clang-x86-64-testbuild
+    - .container-ubuntu-focal-testtmpl
+
+test-ubuntu-focal-clang-debug:
+  extends:
+    - .clang-x86-64-testbuild-debug
+    - .container-ubuntu-focal-testtmpl